"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
require('isomorphic-fetch');
var rxjs_1 = require('rxjs');
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var patch_parser_1 = require('./patch-parser');
var apollo_client_1 = require('apollo-client');
var graphql_tag_1 = require('graphql-tag');
var networkInterface = apollo_client_1.createNetworkInterface({ uri: 'https://graphql-explorer.githubapp.com/graphql/proxy' });
var client = new apollo_client_1.default({
    networkInterface: networkInterface,
});
function capitalizeFirstLetter(message) {
    return message.charAt(0).toUpperCase() + message.slice(1);
}
function prepareSummary(message) {
    return capitalizeFirstLetter(message.trim());
}
function parseOutStepNumberAndComment(arr) {
    arr.forEach(function (parsedPatch) {
        var splitMessage = parsedPatch.message.split(':');
        if (splitMessage.length > 1) {
            var stepNumber = splitMessage[0].split(' ')[1];
            if (!stepNumber) {
                stepNumber = splitMessage[0].split(' ')[0];
            }
            parsedPatch.stepNumber = stepNumber.trim();
            if (splitMessage[1]) {
                parsedPatch.summary = prepareSummary(splitMessage[1]);
            }
        }
    });
    return arr;
}
function doMapping(parsedData) {
    var stepToPatch = {};
    parsedData.forEach(function (parsedPatch) {
        stepToPatch[parsedPatch.stepNumber] = parsedPatch;
    });
    return stepToPatch;
}
var cache = {};
var TutorialRegistryCache = (function () {
    function TutorialRegistryCache(http) {
        this.http = http;
    }
    TutorialRegistryCache.prototype.load = function (id, revision, tutorialData) {
        var _this = this;
        if (cache[id]) {
            return rxjs_1.Observable.of(cache[id]);
        }
        else {
            rxjs_1.Observable.fromPromise(client.query({
                forceFetch: true,
                query: (_a = ["\n            query {\n                repository (name:\"Ionic2CLI-Meteor-WhatsApp\", owner: \"Urigo\"){\n                    ref(qualifiedName: \"new-commits\") {\n                        target {\n                            ... on Commit {\n                                history(path: \"manuals/templates/root.md\", first: 100) {\n                                    edges {\n                                        node {\n                                            oid\n                                        }\n                                    }\n                                }\n                            }\n                        }\n                    }\n                }\n            }"], _a.raw = ["\n            query {\n                repository (name:\"Ionic2CLI-Meteor-WhatsApp\", owner: \"Urigo\"){\n                    ref(qualifiedName: \"new-commits\") {\n                        target {\n                            ... on Commit {\n                                history(path: \"manuals/templates/root.md\", first: 100) {\n                                    edges {\n                                        node {\n                                            oid\n                                        }\n                                    }\n                                }\n                            }\n                        }\n                    }\n                }\n            }"], graphql_tag_1.default(_a))
            }))
                .map(function (res) {
                console.log('apollo res:', res);
                return res.data.repository.ref.target.history.edges[0].node.oid;
            })
                .flatMap(function (firstCommitId) {
                console.log(firstCommitId);
                var url = 'https://github.com/' + tutorialData.gitHub + '/compare/' + firstCommitId + '...' + revision + '.patch';
                return _this.http.get(url);
            })
                .map(function (res) { return res['text'](); })
                .map(patch_parser_1.parseMultiPatch)
                .map(parseOutStepNumberAndComment)
                .map(doMapping)
                .map(function (parsedTutorial) {
                var cacheItem = {
                    steps: parsedTutorial,
                    tutorial: tutorialData
                };
                cache[id] = cacheItem;
                return cacheItem;
            });
        }
        var _a;
    };
    TutorialRegistryCache = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http])
    ], TutorialRegistryCache);
    return TutorialRegistryCache;
}());
exports.TutorialRegistryCache = TutorialRegistryCache;
//# sourceMappingURL=tutorials-registry-cache.js.map